.586p
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\shell32.inc
include \masm32\include\wsock32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\shell32.lib
includelib \masm32\lib\wsock32.lib

WM_SHELLNOTIFY equ WM_USER+5
IDI_TRAY       equ 0
IDM_FORWARD    equ 1000
IDM_REFRESH    equ 1010
IDM_BACKWARD   equ 1020
IDM_MESSAGE    equ 1030
IDM_EXIT	   equ 1040

WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD

.data
  ClassName 	db "TabTrayWinClass",0
  AppName  		db "TabTray",0
  ForwardString	db "&Forward    Ctrl-Tab",0
  RefreshString   db "&Refresh    F5",0
  BackwardString	db "&Backward   Ctrl-Shift-Tab",0
  MessageString	db "&MessageBox",0
  ExitString	db "E&xit Program",0
  szTipMsg        db "Click for IP address(es)",0
  RunWindowClass          db          'MozillaWindowClass', 0
 ;   RunWindowClass          db          'Internet_Explorer_Server',0
 ;   RunWindowClass          db          'IEFrame',0
  RunWindowText           db          'Google - Mozilla Firefox', 0

ALIGN 16
  hInstance	      dd  ?
  hPopupMenu	dd  ?

  BHandle         dd  0    ; browser handle
  OHandle         dd  0    ; restore handle
  milliDelay      dd  20   ; delay between key presses
  BrowserFound    dd  0

  junk2           dd  0
  junk3           dd  0

  note        NOTIFYICONDATA <>
  Buffer      db 256 dup (?)
  WSAData     WSADATA <>
  HostMsg     db "Right click for more options.",0  ;13      ; HostMsg     db "Click to recheck IP(s)",13
  HostAddr    db "Text",256 dup (0)
              db 256 dup (0)
  HostName    db "Some",256 dup (0)
  edy         dd ?
  esy         dd ?
  ecy         dd ?

 ; HostName          db "ComputerABC",0
 ; HostAddr          db "192.168.0.1",13,10         ; IPAddress
 ;                   db "192.168.0.3",13,10
 ;                   db "192.168.0.5",13,10
 ;                   db "192.168.0.7",0

.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax

 ;       invoke WSAStartup, 101h,ADDR WSAData
 ;       or eax,eax
 ;       jnz @sockerrInit
 ;   
 ;       invoke gethostname, ADDR HostName,SIZEOF HostName
 ;       or eax,eax
 ;       jnz @nameerrInit
 ; 
 ;       invoke gethostbyname, ADDR HostName
 ;       or eax,eax
 ;       jz @nonameInit
 ; 
 ;       push edi
 ;       push esi
 ;       mov edi,OFFSET HostAddr
 ;       mov eax,[eax+12] ;;hostent.h_list
 ;       mov edx,eax
 ;     @7:
 ;       mov eax,[edx]
 ;       or eax,eax
 ;       jz @showInit
 ;       mov eax,[eax]
 ;       push edx
 ;       invoke inet_ntoa, eax
 ;       mov esi,eax
 ;     @@:
 ;       mov al,[esi]
 ;       mov [edi],al
 ;       inc edi
 ;       inc esi
 ;       or al,al
 ;       jnz @B
 ;       dec edi
 ;       mov BYTE PTR[edi],13
 ;       inc edi
 ;       pop edx
 ;       add edx,4
 ;       jmp @7
 ;   
 ;     @showInit:
 ;       dec edi
 ;       mov [edi],al ;since jmp was because eax==0
 ;       pop esi
 ;       pop edi
 ; 
 ;       invoke WSACleanup

    @sockerrInit:
    @nameerrInit:
    @nonameInit:

	invoke WinMain, hInstance,NULL,NULL, SW_SHOWDEFAULT
	invoke ExitProcess,eax


WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW or CS_DBLCLKS
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInst
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_APPWORKSPACE
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	invoke RegisterClassEx, addr wc

	invoke CreateWindowEx,WS_EX_CLIENTEDGE,ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPED+WS_CAPTION+WS_SYSMENU+WS_MINIMIZEBOX+WS_MAXIMIZEBOX+WS_VISIBLE+WS_MINIMIZE,\
           CW_USEDEFAULT,CW_USEDEFAULT,350,200,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
	.while TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.endw
	mov eax,msg.wParam
	ret
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL pt:POINT
	.if uMsg==WM_CREATE
		invoke CreatePopupMenu
		mov hPopupMenu,eax
		invoke AppendMenu,hPopupMenu,MF_STRING,IDM_FORWARD, addr ForwardString
		invoke AppendMenu,hPopupMenu,MF_STRING,IDM_REFRESH, addr RefreshString
		invoke AppendMenu,hPopupMenu,MF_STRING,IDM_BACKWARD,addr BackwardString
            invoke AppendMenu,hPopupMenu,MF_STRING,IDM_MESSAGE, addr MessageString
		invoke AppendMenu,hPopupMenu,MF_STRING,IDM_EXIT,    addr ExitString
	.elseif uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.elseif uMsg==WM_SIZE
		.if wParam==SIZE_MINIMIZED
			mov note.cbSize,sizeof NOTIFYICONDATA
			push hWnd
			pop note.hwnd
			mov note.uID,IDI_TRAY
			mov note.uFlags,NIF_ICON+NIF_MESSAGE+NIF_TIP
			mov note.uCallbackMessage,WM_SHELLNOTIFY
			invoke LoadIcon,NULL,IDI_WINLOGO
			mov note.hIcon,eax
			invoke lstrcpy,addr note.szTip,addr HostMsg   ; HostAdrr  szTipMsg
			invoke ShowWindow,hWnd,SW_HIDE
			invoke Shell_NotifyIcon,NIM_ADD,addr note
		.endif
	.elseif uMsg==WM_COMMAND
		.if lParam==0
  ;                  invoke  FindWindow, OFFSET RunWindowClass, OFFSET RunWindowText
                  invoke  FindWindow, OFFSET RunWindowClass, NULL
                  mov     BHandle, eax
                  mov     BrowserFound, 0
                  test    eax , eax
                  je      @F
                  mov     BrowserFound, 1
                @@:
			; invoke Shell_NotifyIcon,NIM_DELETE,addr note
			mov eax,wParam

			.if     ax==IDM_FORWARD
                     .if BrowserFound==1
                        invoke GetForegroundWindow  ; save handle of current foreground window
                        mov    OHandle,eax
                      
                        invoke SetForegroundWindow, BHandle ; set to Browser
                      
                        invoke  keybd_event, VK_CONTROL, 0, 0, 0       ; Do a Ctrl-Tab (forward a Tab)
                        invoke  Sleep, milliDelay
                        invoke  keybd_event, VK_TAB,     0, 0, 0
                        invoke  Sleep, milliDelay
                      
                        invoke  keybd_event, VK_CONTROL, 0, KEYEVENTF_KEYUP, 0
                        invoke  Sleep, milliDelay
                        invoke  keybd_event, VK_TAB,     0, KEYEVENTF_KEYUP, 0
                        invoke  Sleep, milliDelay
                      
                        invoke  SetForegroundWindow, OHandle  ; restore previous foreground window
                     .endif
                  .elseif ax==IDM_REFRESH
                     .if BrowserFound==1
                        invoke GetForegroundWindow  ; save handle of current foreground window
                        mov    OHandle,eax
                      
                        invoke SetForegroundWindow, BHandle ; set to Browser
                      
                        invoke  keybd_event, VK_F5,      0, 0, 0       ; Do a F5 (refresh the Tab)
                        invoke  Sleep, milliDelay
                      
                        invoke  keybd_event, VK_F5,      0, KEYEVENTF_KEYUP, 0
                        invoke  Sleep, milliDelay

                        invoke  SetForegroundWindow, OHandle  ; restore previous foreground window
                     .endif
                  .elseif ax==IDM_BACKWARD
                     .if BrowserFound==1
                        invoke GetForegroundWindow  ; save handle of current foreground window
                        mov    OHandle,eax
                      
                        invoke SetForegroundWindow, BHandle ; set to Browser

                        invoke  keybd_event, VK_CONTROL, 0, 0, 0       ; Do a Ctrl-Shift-Tab (backward a Tab)
                        invoke  Sleep, milliDelay
                        invoke  keybd_event, VK_SHIFT,   0, 0, 0
                        invoke  Sleep, milliDelay
                        invoke  keybd_event, VK_TAB,     0, 0, 0
                        invoke  Sleep, milliDelay
                      
                        invoke  keybd_event, VK_CONTROL, 0, KEYEVENTF_KEYUP, 0
                        invoke  Sleep, milliDelay
                        invoke  keybd_event, VK_SHIFT,   0, KEYEVENTF_KEYUP, 0
                        invoke  Sleep, milliDelay
                        invoke  keybd_event, VK_TAB,     0, KEYEVENTF_KEYUP, 0
                        invoke  Sleep, milliDelay
                      
                        invoke  SetForegroundWindow, OHandle  ; restore previous foreground window
                     .endif
                  .elseif ax==IDM_MESSAGE
                        invoke lstrcpy,addr note.szTip,addr HostMsg   ; HostAdrr  szTipMsg

            	      invoke Shell_NotifyIcon,NIM_MODIFY,addr note

                        invoke MessageBox,NULL,ADDR HostAddr,ADDR HostName,\
                               MB_SETFOREGROUND+MB_SERVICE_NOTIFICATION+MB_TOPMOST+MB_OK
			.else ; ax==IDM_EXIT
			    invoke Shell_NotifyIcon,NIM_DELETE,addr note				
                      invoke DestroyWindow,hWnd
			.endif
		.endif

	.elseif uMsg==WM_SHELLNOTIFY
		.if wParam==IDI_TRAY
			.if lParam==WM_RBUTTONDOWN
				invoke GetCursorPos,addr pt
				invoke TrackPopupMenu,hPopupMenu,TPM_RIGHTALIGN,pt.x,pt.y,NULL,hWnd,NULL
			.elseif lParam==WM_LBUTTONUP
				invoke SendMessage,hWnd,WM_COMMAND,IDM_FORWARD, 0   ; IDM_MESSAGE,0   IDM_REFRESH,0
			.elseif lParam==WM_LBUTTONDBLCLK
				invoke SendMessage,hWnd,WM_COMMAND,IDM_BACKWARD,0   ; IDM_MESSAGE,0   IDM_REFRESH,0
		 	      ;  invoke SendMessage,hWnd,WM_COMMAND,IDM_REFRESH, 0   ; IDM_MESSAGE,0   IDM_REFRESH,0
                  ; maybe some message could be checked here causing a recheck of IP address(es)
			.endif
		.endif
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.endif
	xor eax,eax
	ret
WndProc endp

end start

 ; 	.elseif uMsg==WM_USER+5 ; to often             ; WM_MOUSEMOVE didn't work
 ; 
 ;             jmp @PastTip
 ; 
 ;             invoke WSAStartup, 101h,ADDR WSAData
 ;             or eax,eax
 ;             jnz @sockerrTip
 ;         
 ;             invoke gethostname, ADDR HostName,SIZEOF HostName
 ;             or eax,eax
 ;             jnz @nameerrTip
 ;         
 ;             invoke gethostbyname, ADDR HostName
 ;             or eax,eax
 ;             jz @nonameTip
 ; 
 ;             push edi
 ;             push esi
 ;             mov edi,OFFSET HostAddr
 ;             mov eax,[eax+12] ;;hostent.h_list
 ;             mov edx,eax
 ;           @2:
 ;             mov eax,[edx]
 ;             or eax,eax
 ;             jz @showTip
 ;             mov eax,[eax]
 ;             push edx
 ;             invoke inet_ntoa, eax
 ;             mov esi,eax
 ;           @@:
 ;             mov al,[esi]
 ;             mov [edi],al
 ;             inc edi
 ;             inc esi
 ;             or al,al
 ;             jnz @B
 ;             dec edi
 ;             mov BYTE PTR[edi],13
 ;             inc edi
 ;             pop edx
 ;             add edx,4
 ;             jmp @2
 ;         
 ;           @showTip:
 ;             dec edi
 ;             mov [edi],al ;since jmp was because eax==0
 ;             pop esi
 ;             pop edi
 ; 
 ;             invoke WSACleanup
 ; 
 ;        @sockerrTip:
 ;        @nameerrTip:
 ;        @nonameTip:
 ; 
 ;             mov ecy, ecx
 ;             mov esy, esi
 ;             mov edy, edi
 ;             mov ecx, 64                     ; 256
 ;             mov esi, OFFSET HostAddr        ; mov edi, OFFSET HostAddr
 ;             mov edi, OFFSET note.szTip      ; HostAddrDbg
 ;           @@:
 ;             sub ecx, 4
 ;             mov eax, [esi+ecx]
 ;             mov [edi+ecx], eax
 ;             or  ecx,ecx
 ;             jnz @B
 ;             mov edi, edy
 ;             mov esi, esy
 ;             mov ecx, ecy
 ; 
 ;        @PastTip:
 ; 	      invoke Shell_NotifyIcon,NIM_MODIFY,addr note


;====================================
 ; 			.if ax==IDM_MESSAGE || ax==IDM_REFRESH
 ; 
 ;                         invoke WSAStartup, 101h,ADDR WSAData
 ;                         or eax,eax
 ;                         jnz @sockerr
 ;                     
 ;                         invoke gethostname, ADDR HostName,SIZEOF HostName
 ;                         or eax,eax
 ;                         jnz @nameerr
 ;                     
 ;                         invoke gethostbyname, ADDR HostName
 ;                         or eax,eax
 ;                         jz @noname
 ; 
 ;                         push edi
 ;                         push esi
 ;                         mov edi,OFFSET HostAddr
 ;                         mov eax,[eax+12] ;;hostent.h_list
 ;                         mov edx,eax
 ;                       @1:
 ;                         mov eax,[edx]
 ;                         or eax,eax
 ;                         jz @show
 ;                         mov eax,[eax]
 ;                         push edx
 ;                         invoke inet_ntoa, eax
 ;                         mov esi,eax
 ;                       @@:
 ;                         mov al,[esi]
 ;                         mov [edi],al
 ;                         inc edi
 ;                         inc esi
 ;                         or al,al
 ;                         jnz @B
 ;                         dec edi
 ;                         mov BYTE PTR[edi],13
 ;                         inc edi
 ;                         pop edx
 ;                         add edx,4
 ;                         jmp @1
 ;                     
 ;                       @show:
 ;                         dec edi
 ;                         mov [edi],al ;since jmp was because eax==0
 ;                         pop esi
 ;                         pop edi
 ; 
 ;                         invoke WSACleanup
 ; 
 ;                    @sockerr:
 ;                    @nameerr:
 ;                    @noname:
 ;  ;                         jmp Past
 ;  ; 
 ;  ;                         mov ecy, ecx
 ;  ;                         mov esy, esi
 ;  ;                         mov edy, edi
 ;  ;                         mov ecx, 64
 ;  ;                         mov esi, OFFSET HostMsg         ; mov edi, OFFSET HostAddr
 ;  ;                         mov edi, OFFSET note.szTip
 ;  ;                       @@:
 ;  ;                         sub ecx, 4
 ;  ;                         mov eax, [esi+ecx]
 ;  ;                         mov [edi+ecx], eax
 ;  ;                         or  ecx,ecx
 ;  ;                         jnz @B
 ;  ;                         mov edi, edy
 ;  ;                         mov esi, esy
 ;  ;                         mov ecx, ecy
 ;===============================================================
 ;                         invoke  FindWindow, OFFSET RunWindowClass, NULL     ; OFFSET RunWindowText
 ;                         mov     BHandle, eax
 ;                         mov     BrowserFound, 0
 ;                         test    eax , eax
 ;                         je      @F
 ;                         mov     BrowserFound, 1
 ;                       @@:
 ;                            .if BrowserFound==1
 ;                               invoke GetForegroundWindow  ; save handle of current foreground window
 ;                               mov    OHandle,eax
 ; 
 ;                               invoke SetForegroundWindow, BHandle ; set to Browser
 ; 
 ;                               invoke  keybd_event, VK_CONTROL, 0, 0, 0       ; Do a Ctrl-Tab (forward a Tab)
 ;                               invoke  Sleep, milliDelay
 ;                               invoke  keybd_event, VK_TAB,     0, 0, 0
 ;                               invoke  Sleep, milliDelay
 ;                             
 ;                               invoke  keybd_event, VK_CONTROL, 0, KEYEVENTF_KEYUP, 0
 ;                               invoke  Sleep, milliDelay
 ;                               invoke  keybd_event, VK_TAB,     0, KEYEVENTF_KEYUP, 0
 ;                               invoke  Sleep, milliDelay
 ;                             
 ;                               invoke  SetForegroundWindow, OHandle  ; restore previous foreground window
 ;                            .endif
